from dios import *
from test.test_setup import *
import pytest


def _test(res, exp):

    if isinstance(exp, pd.DataFrame):
        t = dios_eq_df(res, exp, with_msg=True)
        assert t[0], t[1]

    else:
        assert type(exp) == type(res)

        if isinstance(exp, pd.Series):
            t = diosSeries_eq_dfSeries(res, exp, with_msg=True)
            assert t[0], t[1]

        # scalars
        else:
            assert res == exp


@pytest.mark.parametrize('idxer', INDEXERS)
def test_dflike__getitem__(df_, dios_, idxer):
    print(idxer)
    exp = df_[idxer]
    res = dios_[idxer]
    _test(res, exp)


@pytest.mark.parametrize('locL', LOC_L)
@pytest.mark.parametrize('locR', LOC_R)
def test_dflike__get_loc__(df_, dios_, locL, locR):
    print(locL)
    print(locR)
    exp = df_.loc[locL, locR]
    res = dios_.loc[locL, locR]
    _test(res, exp)


@pytest.mark.parametrize('ilocL', ILOC_L)
@pytest.mark.parametrize('ilocR', ILOC_R)
def test_dflike__get_iloc__(df_, dios_, ilocL, ilocR):
    print(ilocL)
    print(ilocR)
    exp = df_.iloc[ilocL, ilocR]
    res = dios_.iloc[ilocL, ilocR]
    _test(res, exp)


VALS = [99, ]

@pytest.mark.parametrize('idxer', INDEXERS)
@pytest.mark.parametrize('val', VALS)
def test_dflike__setitem__(df_, dios_, idxer, val):
    print(idxer)
    exp = df_
    res = dios_
    exp[idxer] = val
    res[idxer] = val
    _test(res, exp)


@pytest.mark.parametrize('locL', LOC_L)
@pytest.mark.parametrize('locR', LOC_R)
@pytest.mark.parametrize('val', VALS)
def test_dflike__set_loc__(df_, dios_, locL, locR, val):
    print(locL)
    print(locR)
    exp = df_
    res = dios_
    exp.loc[locL, locR] = val
    res.loc[locL, locR] = val
    _test(res, exp)


@pytest.mark.parametrize('ilocL', ILOC_L)
@pytest.mark.parametrize('ilocR', ILOC_R)
@pytest.mark.parametrize('val', VALS)
def test_dflike__set_iloc__(df_, dios_, ilocL, ilocR, val):
    print(ilocL)
    print(ilocR)
    exp = df_
    res = dios_
    exp.iloc[ilocL, ilocR] = val
    res.iloc[ilocL, ilocR] = val
    _test(res, exp)

